// DtvEngine.cpp: CDtvEngine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DtvEngine.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// CDtvEngine \z/
//////////////////////////////////////////////////////////////////////

CDtvEngine::CDtvEngine(void)
	: m_pDtvEngineHandler(NULL)
	, m_wCurService(0U)
	, m_BonSrcDecoder(this)
	, m_TsPacketParser(this)
	, m_TsDescrambler(this)
	, m_ProgManager(this)
	, m_MediaViewer(this)
	, m_MediaTee(this)
	, m_FileWriter(this)
	, m_FileReader(this)
	, m_bIsFileMode(false)
{

}

CDtvEngine::~CDtvEngine(void)
{
	CloseEngine();
}

const bool CDtvEngine::OpenEngine(CDtvEngineHandler *pDtvEngineHandler, HWND hHostHwnd,HWND hMessageDrainHwnd,HMODULE hBonDrvDll)
{
	// SɎb
	CloseEngine();

	// Ot\}
	//
	// m_BonSrcDecoder or m_FileReader
	//		
	// m_TsPacketParser
	//		
	// m_TsDescrambler
	//		
	// m_MediaTee
	//						
	// m_ProgManager	m_FileWriter
	//		
	// m_MediaViewer

	// fR[_Ot\z
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser);	// Output #0 : CMediaData
	m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler);	// Output #0 : CTsPacket
	m_TsDescrambler.SetOutputDecoder(&m_MediaTee);			// Output #0 : CTsPacket
	m_MediaTee.SetOutputDecoder(&m_ProgManager, 0UL);		// Output #0 : CTsPacket
	m_MediaTee.SetOutputDecoder(&m_FileWriter, 1UL);		// Output #1 : CTsPacket
	m_ProgManager.SetOutputDecoder(&m_MediaViewer);			// Output #0 : CTsPacket

	// UZbg
	ResetEngine();

	// Cxgnhݒ
	m_pDtvEngineHandler = pDtvEngineHandler;

	try{
		// `[iJ
		if(!m_BonSrcDecoder.OpenTuner(hBonDrvDll))throw 1UL;
	
		// B-CASJ[hJ
		if(!m_TsDescrambler.OpenBcasCard())throw 2UL;

		// r[AJ
		if(!m_MediaViewer.OpenViewer(hHostHwnd,hMessageDrainHwnd))throw 3UL;
		}
	catch(DWORD dwErrorNo){
		// G[
		switch(dwErrorNo){
			case 1UL :	::AfxMessageBox(TEXT("`[ȉɎs܂B"));		break;
			case 2UL :	::AfxMessageBox(TEXT("B-CASJ[h̏Ɏs܂B"));	break;
			case 3UL :	::AfxMessageBox(TEXT("DirectShow̏Ɏs܂B"));	break;
			}		
		
		CloseEngine();
		
		return false;
		}
	
	return true;
}

const bool CDtvEngine::CloseEngine(void)
{
	// fR[_N[Y
	m_BonSrcDecoder.CloseTuner();
	m_TsDescrambler.CloseBcasCard();
	m_MediaViewer.CloseViewer();

	// Cxgnh
	m_pDtvEngineHandler = NULL;

	return true;
}

const bool CDtvEngine::ResetEngine(void)
{
	// fR[_OtZbg
	m_BonSrcDecoder.Reset();

	return true;
}

const bool CDtvEngine::EnablePreview(const bool bEnable)
{
	if(bEnable){
		// vr[L
		if(!m_BonSrcDecoder.Play())return false;
		if(!m_MediaViewer.Play())return false;
		}
	else{
		// vr[
		if(!m_MediaViewer.Stop())return false;
		if(!m_BonSrcDecoder.Stop())return false;
		}

	return true;
}

const bool CDtvEngine::SetViewSize(const int x,const int y,const int aspect_rate_x,const int aspect_rate_y)
{
	return m_MediaViewer.SetViewSize(x,y,aspect_rate_x,aspect_rate_y);
}

const bool CDtvEngine::SwitchFullscreen()
{
	return m_MediaViewer.SwitchFullscreen();
}

const bool CDtvEngine::SetChannel(const BYTE byTuningSpace, const WORD wChannel)
{
	// `lύX
	return  m_BonSrcDecoder.SetChannel((BYTE)wChannel);
}

const bool CDtvEngine::SetService(const WORD wService)
{
	// T[rXύX
	if(wService < m_ProgManager.GetServiceNum()){
		WORD wVideoPID = 0xFFFF;
		WORD wAudioPID = 0xFFFF;
	
		m_wCurService = wService;
		m_ProgManager.GetServiceEsPID(&wVideoPID, &wAudioPID, m_wCurService);
		m_MediaViewer.SetVideoPID(wVideoPID);
		m_MediaViewer.SetAudioPID(wAudioPID);
		
		return true;
		}

	return false;
}

const WORD CDtvEngine::GetService(void) const
{
	// T[rX擾
	return m_wCurService;
}

const bool CDtvEngine::PlayFile(LPCTSTR lpszFileName)
{
	// OtŜ̔rȂƂ܂ƂɓȂII

	// Đ̏ꍇ͕
	m_FileReader.StopReadAnsync();

	// XbhI҂
	while(m_FileReader.IsAnsyncReadBusy()){
		::Sleep(1UL);
		}

	m_FileReader.CloseFile();

	// foCXĐ̏ꍇ̓Otč\z
	if(!m_bIsFileMode){
		m_BonSrcDecoder.Stop();
		m_BonSrcDecoder.SetOutputDecoder(NULL);
		m_FileReader.SetOutputDecoder(&m_TsPacketParser);
		}

	try{
		// OtZbg
		m_FileReader.Reset();

		// t@CI[v
		if(!m_FileReader.OpenFile(lpszFileName))throw 0UL;
		
		// 񓯊ĐJn
		if(!m_FileReader.StartReadAnsync())throw 1UL;
		}
	catch(const DWORD dwErrorStep){
		// G[
		StopFile();
		return false;
		}

	m_bIsFileMode = true;

	return true;
}

void CDtvEngine::StopFile(void)
{
	// OtŜ̔rȂƂ܂ƂɓȂII

	m_bIsFileMode = false;

	// Đ̏ꍇ͕
	m_FileReader.StopReadAnsync();
	
	// XbhI҂
	while(m_FileReader.IsAnsyncReadBusy()){
		::Sleep(1UL);
		}

	m_FileReader.CloseFile();
	
	// Otč\z
	m_FileReader.SetOutputDecoder(NULL);
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser);
	m_BonSrcDecoder.Play();
}

const DWORD CDtvEngine::GetLastError(void) const
{
	return 0UL;
}

const DWORD CDtvEngine::SendDtvEngineEvent(const DWORD dwEventID, PVOID pParam)
{
	// CxgnhɃCxg𑗐M
	if(m_pDtvEngineHandler){
		return m_pDtvEngineHandler->OnDtvEngineEvent(this, dwEventID, pParam);
		}

	return 0UL;
}

const DWORD CDtvEngine::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if(pDecoder == &m_ProgManager){
		
		// vO}l[W̃Cxg
		switch(dwEventID){
			case CProgManager::EID_SERVICE_LIST_UPDATED :
				// T[rX̍\ω
				SetService(0U);
				SendDtvEngineEvent(0UL, static_cast<PVOID>(&m_ProgManager));

				return 0UL;
				
			case CProgManager::EID_SERVICE_INFO_UPDATED :
				// T[rXXVꂽ
				SendDtvEngineEvent(0UL, static_cast<PVOID>(&m_ProgManager));
				
				return 0UL;
			}
		}
	else if(pDecoder == &m_FileReader){
		
		CFileReader *pFileReader = dynamic_cast<CFileReader *>(pDecoder);
		
		// t@C[_̃Cxg
		switch(dwEventID){
			case CFileReader::EID_READ_ASYNC_START :
				// 񓯊[hJn
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_END :
				// 񓯊[hI
				return 0UL;
			
			case CFileReader::EID_READ_ASYNC_POSTREAD :
				// 񓯊[h
				
				if(pFileReader->GetReadPos() >= pFileReader->GetFileSize()){
					// ŏɊ߂([vĐ)
					pFileReader->SetReadPos(0ULL);
					pFileReader->Reset();
					}
				
				return 0UL;
			}		
		}

	return 0UL;
}


//////////////////////////////////////////////////////////////////////
// CDtvEngineHandler \z/
//////////////////////////////////////////////////////////////////////

const DWORD CDtvEngineHandler::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// ftHg̏
	return 0UL;
}
